---
layout: markdown_page
title: "Category Direction - Web IDE"
description: "GitLab want to make it easier for engineers to work on secondary development items in the Web IDE by removing barriers to the code review process. Learn more!"
canonical_path: "/direction/create/web_ide/"
---

- TOC
{:toc}

## Web IDE

| | |
| --- | --- |
| Stage | [Create](/direction/dev/#create) |
| Maturity | [Viable](/direction/maturity/) |
| Content Last Reviewed | `2020-10-14` |

### Introduction and how you can help
Thanks for visiting this direction page on the Web IDE in GitLab. This page belongs to the [Editor](/handbook/product/categories/#editor-group) group of the Create stage and is maintained by Eric Schurter ([E-Mail](mailto:eschurter@gitlab.com)).

This direction is constantly evolving and everyone can contribute:

 - Please comment and contribute in the linked [issues](https://gitlab.com/gitlab-org/gitlab/issues?label_name%5B%5D=Category%3AWeb+IDE) and [epics](https://gitlab.com/groups/gitlab-org/-/epics?label_name[]=Category%3AWeb%20IDE) on this page. Sharing your feedback directly on GitLab.com  or submitting a Merge Request to this page are the best ways to contribute to our strategy.
 - Please share feedback directly via email, Twitter, or [schedule a video call](https://calendly.com/gitlabkai). If you're a GitLab user and have direct knowledge of your need for the Web IDE, we'd especially love to hear from you.

### Overview
Code Editors are one of the most important tools in a software engineers toolkit because the majority of their work is writing and working with code. They're customized with extensions for programming languages, coding standards and frameworks and more for the type of working being done. They're also optimized for connecting to development runtime environments and services engineers need to do their work. The context in which engineers use this tool dictates the type of configuration required.

Software development is an iterative process that involves requesting feedback from peers (Developers, Designers, Product Mangers etc), and responding to that feedback. In GitLab, this is done using a Merge Request. Reviewing is in fact a specialized editing task (other professions would call this same task editing), for example suggesting specific changes to functions, documentation, and interface text. A local development environment is often not ideal for these editing tasks:

  - As a developer reviewing the merge request this often involves checking the code out locally and creating an environment for that review. Sometimes this process can be complicated due to local dependencies, their own local development branch, database migrations and other issues which prevent just cleanly changing branches. Reviews also involve reviewing the code changes to gain understanding and providing feedback to the author of the MR in the form of code suggestions, patches and other general comments.
  - As a designer or product manager setting up and maintaining an environment to perform reviews may not be feasible. Reviewing these changes inside of a review application is valuable, but it can be hard to provide as actionable comments back to the MR.
  - As a the author, responding to feedback this often involves leaving MR feedback open in one window while working in an editor in a different window. Feedback in the form of suggestions and patch files needs to be handled outside of the MR interface and back in the local development environment. At the same time some feedback requires manually updating comments and threads that feedback has been actioned after the changes have been pushed back to the MR.

Configuration files are also common to software development and the tools of the DevOps life cycle. Files like gitlab-ci.yml or CODEOWNERS can be difficult to use because they need to be both syntactically (correct commas, quotes, value types etc) and semantically valid (expresses what you intended it to). Local development environments can be configured with syntax checkers, and schemas to help verify syntactic correctness, but lack the context for deeper features.

GitLab CI is fast and highly configurable within GitLab, but it can be hard to remember all the configuration parameters for your goal and a typo can make the complete configuration invalid. Editing this file often involves having documentation open while make changes. Once those changes have been made users leave their editor to validate the file or commit and wait for feedback from a running pipeline.

Once your GitLab CI configuration has been created and validated, it may be responsible for providing review applications for previewing changes, code quality and coverage reports or vulnerability information. As an engineer who is working on a contribution information contained on these reports must be reconciled within their editor.

GitLab's web editors are familiar to developers, and easy to use for designers, product managers and more. It brings editing capabilities into the context of their current task in GitLab, by providing an editing experience designed for the workflow they're trying to accomplish.

#### Scope of Vision

Our vision for editing inside of GitLab extends to both the Web IDE and our [Web Editor](https://docs.gitlab.com/ee/user/project/repository/web_editor.html). We believe that both task and context are important aspects to consider when choosing an editing experience and we want to focus on providing complete experiences in all areas.

Specificially for the Web Editor we'll be exploring more [In-context single file editing experiences](https://gitlab.com/groups/gitlab-org/-/epics/3601) that present editors inline to the task trying to be accomplished.

### Target Audience and Experience
<!-- An overview of the personas (https://about.gitlab.com/handbook/marketing/strategic-marketing/roles-personas#user-personas) involved in this category. An overview
of the evolving user journeys as the category progresses through minimal,
viable, complete and lovable maturity levels. -->
The software development process involves many people working across various parts of configuration, contribution and review. All of these users work together to advance software projects in their organization.

Engineering personas who are contributing to development, configuring or interacting with continuous integration and reviewing contributions from other team members. Users performing these tasks need tools that allow them to deeply understand the changes and provide meaningful feedback of both comments and code suggestions. These are specifically addressed by the following GitLab Personas:
 - [Sasha (Software Developer)](/handbook/marketing/strategic-marketing/roles-personas/#sasha-software-developer)
 - [Devon (DevOps Engineer)](/handbook/marketing/strategic-marketing/roles-personas/#devon-devops-engineer)

Non-Engineer personas who are focused on reviewing and providing feedback for contributions. These users need tools and features that help them preform reviews of code, documentation and interfaces without requiring local environments or complex configurations. Feedback should be easy to leave and actionable by engineers within their editor. These are specifically addressed by the following GitLab Personas:
 - [Parker (Product Manager)](/handbook/marketing/strategic-marketing/roles-personas/#parker-product-manager)
 - [Presley (Product Designer)](/handbook/marketing/strategic-marketing/roles-personas/#presley-product-designer)
 - [Delaney (Development Team Lead)](/handbook/marketing/strategic-marketing/roles-personas/#delaney-development-team-lead)

#### Challenges to address
<!--
- What needs, goals, or jobs to be done do the users have?
- How do users address these challenges today? What products or work-arounds are utilized?

Provide links to UX Research issues, which validate these problems exist.
-->
**Configuration**
Users who configure projects or GitLab need editing tools to help them be efficient at this process. Creating specialized configuration files for working with GitLab CI or other areas of GitLab benefit from feedback provided directly in the editor.

**Contribution**
Engineering personas who work on contributing directly to the code in projects need to action feedback from the review process. Having easy access to the feedback from reviewers and CI jobs inside of the editor should ensure that it's easy to action.

**Review**
The code review process encompasses both engineering personas and non-engineering personas who contribute through design, product and other feedback. In solving for these users it will be important to make sure that people who want to give feedback are able to easily accomplish that.

### Where we are headed
<!-- Describe the future state for your category. What problems will you solve?
What will the category look like once you've achieved your strategy? Use narrative
techniques to paint a picture of how the lives of your users will benefit from using this
category once your strategy is fully realized -->

Editor [configuration and customization](https://www.cmcrossroads.com/article/beware-ide-risks-standardizing-one-ide) are important parts of IDE experiences. Teams working together often standardize editor configurations through the use of an `.editorconfig` file and developers customize other aspects of the editor to their own preference. Ensuring support for various syntax highlighting preferences and colorization will make working in the Web IDE feel more like a user's local editor.

Providing [first class support for editing](https://gitlab.com/groups/gitlab-org/-/epics/2707) specialized GitLab files like [`.gitlab-ci.yml`](https://gitlab.com/gitlab-org/gitlab/-/issues/218472) file, issue templates and [CODEOWNDERS](https://docs.gitlab.com/ee/user/project/code_owners.html) ensures developers have the tools needed to efficiently accomplish their goals.

Extending the Web IDE to support other GitLab features like [executing CI Jobs](https://gitlab.com/gitlab-org/gitlab/-/issues/213604) and integrating [review app preview](https://gitlab.com/groups/gitlab-org/-/epics/3213) will help provide more feedback to changes in the Web IDE.

Documentation is a less intensive type of engineering effort that requires fewer tools than traditional development environments. Enabling technical users to produce documentation in the Web IDE easier and more quickly will be important as we continue to expand the Web IDE. This includes enhancing markdown tooling and support for more prose based content in the Web IDE.

When working through the code review process users are often trying to understand feedback in the context of their changes. Engineers must examine feedback in one window and then return to their editor to make changes. By expanding [code review tools in to the Web IDE](https://gitlab.com/groups/gitlab-org/-/epics/72) we can help provide that review feedback in the Web IDE so that changes can be made more easily.

It's also important to help users quickly jump to definition and find references while reviewing and editing code within the Web IDE. Supporting [code intelligence](https://gitlab.com/groups/gitlab-org/-/epics/1576) features [in the Web IDE](https://gitlab.com/groups/gitlab-org/-/epics/2332) will move that vision forward.

### Maturity

Currently, GitLab's maturity in the Web IDE is *viable*. Here's why:

 - GitLab currently offers a rich editing experience via the Web IDE. However, the Web IDE does not currently support meaningful development or contribute to secondary engineering activities effectively. Without these features the Web IDE cannot be effectively used to support engineers.

A **[complete](https://gitlab.com/groups/gitlab-org/-/epics/1469)** Web IDE category ensures that the Web IDE is used for tightly integrated editing experiences in GitLab. Moving beyond the focus will be on standardization of editing environments through the use of `.editorconfig` and support for user syntax highlighting (including dark mode). Finally, the Web IDE must provide [1st class editing experiences](https://gitlab.com/groups/gitlab-org/-/epics/2707) for GitLab features.

Part of a **[Lovable](https://gitlab.com/groups/gitlab-org/-/epics/1470)** Web IDE comes by providing support for the Code Review process inside of the Web IDE. This involves support for both leaving and responding to feedback inside of the Web IDE. The Web IDE should also include code navigation features like `Jump to Definition` and `Find References` to better support this process.

### What's Next & Why

We prioritize efforts in the Web IDE that further tighter integrations with other areas of GitLab. We're particularly focused on tighter integrations with code review and GitLab CI/CD.

**In Progress:** Use one editor experience for all file/code editing [&498](https://gitlab.com/groups/gitlab-org/-/epics/498)

Web Editors across GitLab have been standardized on a Monaco based editing experience. The final piece to be completed in 13.6 is to [remove ACE](https://gitlab.com/gitlab-org/gitlab/-/issues/198610) from the GitLab codebase. 

**In Progress:** Linking to specific line numbers in the Web IDE [#21762](https://gitlab.com/gitlab-org/gitlab/-/issues/21762) and Showing merge request discussion icon in the Web IDE gutter [#249625](https://gitlab.com/gitlab-org/gitlab/-/issues/249625)

These issues lay the foundation for providing information in the Web IDE about MR discussions happening and serve as a small primitive to continue exploring the idea.

### What is Not Planned Right Now
<!-- Often it's just as important to talk about what you're not doing as it is to
discuss what you are. This section should include items that people might hope or think
we are working on as part of the category, but aren't, and it should help them understand why that's the case.
Also, thinking through these items can often help you catch something that you should
in fact do. We should limit this to a few items that are at a high enough level so
someone with not a lot of detailed information about the product can understand
the reasoning-->

We're not currently focused on solving the needs of non-engineering based personas with the Web IDE. Non-engineers require a different type of editing experience and that can largely be focused around different types of content. These editing experiences may include documentation or notes based in Markdown, or more WYSIWYG experiences related to content management systems. The [Static Site Editor](https://about.gitlab.com/direction/create/static_site_editor/) will be more focused on these efforts.

While our [complete maturity](/direction/create/web_ide/#maturity) plan also aims to ensure some [compatibility with the iPad](https://gitlab.com/groups/gitlab-org/-/epics/756). We won't be focusing on making the iPad or other mobile devices 1st class devices due to our upstream dependencies on Monaco and various mobile OSs. We also do not have sufficient evidence to support mobile devices as code creation devices inside the Web IDE. As our research in this area continues to expand we may revisit mobile support.

We'd ultimately like the ability for remote development environments to be attached to the Web IDE, but will be addressing this work in the [Editor Extension](https://about.gitlab.com/direction/create/editor_extension/) category. This work will likely be prioritized behind the ability for remote development environments connected to a local VS Code editor.

The Editor group does not have plans to bring real-time collaborative coding features to the Web IDE at this time. While we previously outlined this as a category to focus on, we don't believe there is enough market demand to warrant investment. We'll continue to evaluate the space and may revisit this use case at a later date.

### Competitive Landscape
- [Cloud9](https://aws.amazon.com/cloud9/)
- [Codesandbox](https://codesandbox.io/)
- [Repl.it](https://repl.it/)
- [Koding](https://www.koding.com/)
- [StackBlitz](https://stackblitz.com/)
- [Theia](https://www.theia-ide.org/)
- [Gitpod](https://www.gitpod.io/)
- [Coder](https://coder.com/)
- [Visual Studio Online](https://online.visualstudio.com/)
- [GitHub Codespaces](https://github.com/features/codespaces)

### Analyst Landscape

Currently the Analyst landscape is fragmented on cloud native development experiences. This market will continue to mature as Microsoft pushes ahead with VS Code Online and Amazon further integrates Cloud9 in to their offerings.

[https://www.g2crowd.com/categories/integrated-development-environment-ide](https://www.g2crowd.com/categories/integrated-development-environment-ide)
[https://www.theserverside.com/news/450433105/AWS-Cloud9-IDE-threatens-Microsoft-developer-base](https://www.theserverside.com/news/450433105/AWS-Cloud9-IDE-threatens-Microsoft-developer-base)


<!-- ### Top Customer Success/Sales issue(s) -->
<!-- These can be sourced from the CS/Sales top issue labels when available, internal
surveys, or from your conversations with them.-->

### Top user issue(s)
<!-- This is probably the top popular issue from the category (i.e. the one with the most
thumbs-up), but you may have a different item coming out of customer calls.-->

Top user issues relate to the configurability and customization of the Web IDE. These focus on items like standardizing editor coding style through configuration files and supporting user customization for themes and other preferences.

 - Add Vim keybindings to Web IDE [#22786](https://gitlab.com/gitlab-org/gitlab/-/issues/22786)
 - Support `.gitattributes` and `.editorconfig` for correct encoding [#14222](https://gitlab.com/gitlab-org/gitlab/-/issues/14222)
 - Project custom file templates [#16814](https://gitlab.com/gitlab-org/gitlab/-/issues/16814)

### Top dogfooding issues
<!-- These are sourced from internal customers wanting to [dogfood](/handbook/values/#dogfooding)
the product.-->

GitLab's current internal usage of the Web IDE is very heavily focused around non-technical personas and so there are not any current issues. As we look towards delivering on an IDE for technical users we'll update this section as appropriate.

### Top Vision Item(s)
<!-- What's the most important thing to move your vision forward?-->

The most important items to delivering on the Web IDE Vision are:

 - View merge request discussion in the Web IDE [#22645](https://gitlab.com/gitlab-org/gitlab/-/issues/22645)

It will also be important to standardize current editing experiences on a [single editor](https://gitlab.com/groups/gitlab-org/-/epics/498) to provide more parity across all types of edits.
